<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Views/FileDetails.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Views/FileDetails.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Views/FileDetails.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parameter</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.View <span class="py-keyword">import</span> View</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> Source <span class="py-keyword">import</span> *</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">import</span> os</span>
<a id="line15"></a><span class="lineno"> 15</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileDetails/FileDetails.html">FileDetails</a>(View):</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">   <span class="py-string">&quot;&quot;&quot;A view that creates an index of files, and an index for each file.</span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-string">   First the index of files is created, intended for the top-left frame.</span></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-string">   Second a view is created for each file, listing the major declarations for</span></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="py-string">   that file, eg: classes, global functions, namespaces, etc.&quot;&quot;&quot;</span></span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileDetails/FileDetails.html#register">register</a>(self, frame):</span>
<a id="line23"></a><span class="lineno"> 23</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">      super(FileDetails, self).register(frame)</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">      self.__filename = <span class="py-string">''</span></span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">      self.__title = <span class="py-string">''</span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">      self.link_source = self.processor.has_view(<span class="py-string">'Source'</span>) <span class="py-keyword">and</span> self.processor.sxr_prefix</span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileDetails/FileDetails.html#filename">filename</a>(self):</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">      <span class="py-string">&quot;&quot;&quot;since FileTree generates a whole file hierarchy, this method returns the current filename,</span></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line"><span class="py-string">      which may change over the lifetime of this object&quot;&quot;&quot;</span></span>
<a id="line33"></a><span class="lineno"> 33</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">      <span class="py-keyword">return</span> self.__filename</span>
<a id="line35"></a><span class="lineno"> 35</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileDetails/FileDetails.html#title">title</a>(self):</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">      <span class="py-string">&quot;&quot;&quot;since FileTree generates a while file hierarchy, this method returns the current title,</span></span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line"><span class="py-string">      which may change over the lifetime of this object&quot;&quot;&quot;</span></span>
<a id="line39"></a><span class="lineno"> 39</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">      <span class="py-keyword">return</span> self.__title</span>
<a id="line41"></a><span class="lineno"> 41</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileDetails/FileDetails.html#register_filenames">register_filenames</a>(self):</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Registers a view for each file indexed.&quot;&quot;&quot;</span></span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">      <span class="py-keyword">for</span> filename, file <span class="py-keyword">in</span> self.processor.ir.files.items():</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">         <span class="py-keyword">if</span> file.annotations[<span class="py-string">'primary'</span>]:</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">            filename = self.directory_layout.file_details(filename)</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">            self.processor.register_filename(filename, self, file)</span>
<a id="line49"></a><span class="lineno"> 49</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileDetails/FileDetails.html#process">process</a>(self):</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Creates a view for each known source file.&quot;&quot;&quot;</span></span>
<a id="line52"></a><span class="lineno"> 52</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">      <span class="py-keyword">for</span> filename, file <span class="py-keyword">in</span> self.processor.ir.files.items():</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">         <span class="py-keyword">if</span> file.annotations[<span class="py-string">'primary'</span>]:</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">            self.process_file(filename, file)</span>
<a id="line56"></a><span class="lineno"> 56</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileDetails/FileDetails.html#process_file">process_file</a>(self, filename, file):</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Creates a view for the given file. The view is just an index,</span></span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line"><span class="py-string">      containing a list of declarations.&quot;&quot;&quot;</span></span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">      <span class="py-comment"># set up filename and title for the current view</span></span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">      self.__filename = self.directory_layout.file_details(filename)</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">      <span class="py-comment"># (get rid of ../'s in the filename)</span></span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">      name = filename.split(os.sep)</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">      <span class="py-keyword">while</span> len(name) <span class="py-keyword">and</span> name[0] == <span class="py-string">'..'</span>: <span class="py-keyword">del</span> name[0]</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">      self.__title = os.sep.join(name)+<span class="py-string">' Details'</span></span>
<a id="line67"></a><span class="lineno"> 67</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">      self.start_file()</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">      self.write_navigation_bar()</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">      self.write(element(<span class="py-string">'h1'</span>, os.sep.join(name)))</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">      <span class="py-keyword">if</span> self.link_source:</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">         link = rel(self.filename(),</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">                    self.directory_layout.file_source(filename))</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">         self.write(div(<span class="py-string">''</span>, href(link, <span class="py-string">'source code'</span>, target=<span class="py-string">'content'</span>)) + <span class="py-string">'\n'</span>)</span>
<a id="line75"></a><span class="lineno"> 75</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">      <span class="py-comment"># Print list of includes</span></span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">      <span class="py-keyword">try</span>:</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">         <span class="py-comment"># Only show files from the project</span></span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">         includes = [i <span class="py-keyword">for</span> i <span class="py-keyword">in</span> file.includes <span class="py-keyword">if</span> i.target.annotations[<span class="py-string">'primary'</span>]]</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">         self.write(<span class="py-string">'&lt;h2 class=&quot;heading&quot;&gt;Includes from this file:&lt;/h2&gt;'</span>)</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">         <span class="py-keyword">if</span> <span class="py-keyword">not</span> includes:</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">            self.write(<span class="py-string">'&lt;p&gt;No includes.&lt;/p&gt;\n'</span>)</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">         <span class="py-keyword">else</span>:</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">            self.write(<span class="py-string">'&lt;ul&gt;\n'</span>)</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">            <span class="py-keyword">for</span> include <span class="py-keyword">in</span> includes:</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">               target_filename = include.target.name</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">               <span class="py-keyword">if</span> include.is_next: idesc = <span class="py-string">'include_next '</span></span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">               <span class="py-keyword">else</span>: idesc = <span class="py-string">'include '</span></span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">               <span class="py-keyword">if</span> include.is_macro: idesc = idesc + <span class="py-string">'from macro '</span></span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">               link = rel(self.filename(), self.directory_layout.file_details(target_filename))</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">               self.write(<span class="py-string">'&lt;li&gt;'</span> + idesc + href(link, target_filename)+<span class="py-string">'&lt;/li&gt;\n'</span>)</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">            self.write(<span class="py-string">'&lt;/ul&gt;\n'</span>)</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">      <span class="py-keyword">except</span>:</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">         <span class="py-keyword">pass</span></span>
<a id="line95"></a><span class="lineno"> 95</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">      self.write(<span class="py-string">'&lt;h2 class=&quot;heading&quot;&gt;Declarations in this file:&lt;/h2&gt;\n'</span>)</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">      <span class="py-comment"># Sort items (by name)</span></span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">      items = [(d.type, d.name, d) <span class="py-keyword">for</span> d <span class="py-keyword">in</span> file.declarations</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">               <span class="py-comment"># We don't want to list (function, template) parameters, and neither 'this'.</span></span>
<a id="line100"></a><span class="lineno">100</span><span class="line">               <span class="py-keyword">if</span> type(d) <span class="py-keyword">is</span> <span class="py-keyword">not</span> ASG.Parameter <span class="py-keyword">and</span> d.type <span class="py-keyword">not</span> <span class="py-keyword">in</span> (<span class="py-string">'this'</span>, <span class="py-string">'parameter'</span>, <span class="py-string">'local variable'</span>)]</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">      <span class="py-comment"># ignore ASG.Builtin</span></span>
<a id="line102"></a><span class="lineno">102</span><span class="line">      items = [i <span class="py-keyword">for</span> i <span class="py-keyword">in</span> items <span class="py-keyword">if</span> <span class="py-keyword">not</span> isinstance(i[2], ASG.Builtin)]</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">      items.sort()</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">      curr_scope = None</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">      curr_type = None</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">      <span class="py-keyword">for</span> decl_type, name, decl <span class="py-keyword">in</span> items:</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">         <span class="py-comment"># Check scope and type to see if they've changed since the last</span></span>
<a id="line108"></a><span class="lineno">108</span><span class="line">         <span class="py-comment"># declaration, thereby forming sections of scope and type</span></span>
<a id="line109"></a><span class="lineno">109</span><span class="line">         decl_scope = name[:-1]</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">         <span class="py-keyword">if</span> decl_scope != curr_scope <span class="py-keyword">or</span> decl_type != curr_type:</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">            <span class="py-keyword">if</span> curr_scope <span class="py-keyword">is</span> <span class="py-keyword">not</span> None:</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">               self.write(<span class="py-string">'\n&lt;/div&gt;\n'</span>)</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">            curr_scope = decl_scope</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">            curr_type = decl_type</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">            <span class="py-keyword">if</span> len(curr_type) <span class="py-keyword">and</span> curr_type[-1] == <span class="py-string">'s'</span>: plural = <span class="py-string">'es'</span></span>
<a id="line116"></a><span class="lineno">116</span><span class="line">            <span class="py-keyword">else</span>: plural = <span class="py-string">'s'</span></span>
<a id="line117"></a><span class="lineno">117</span><span class="line">            <span class="py-keyword">if</span> len(curr_scope):</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">               self.write(<span class="py-string">'&lt;div&gt;&lt;h3&gt;%s%s in %s&lt;/h3&gt;\n'</span>%(</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">                  curr_type.capitalize(), plural, escape(str(curr_scope))))</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">               self.write(<span class="py-string">'&lt;div&gt;&lt;h3&gt;%s%s&lt;/h3&gt;\n'</span>%(curr_type.capitalize(),plural))</span>
<a id="line122"></a><span class="lineno">122</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">         <span class="py-comment"># Format this declaration</span></span>
<a id="line124"></a><span class="lineno">124</span><span class="line">         entry = self.processor.toc[name]</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">         label = escape(str(curr_scope.prune(name)))</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">         label = replace_spaces(label)</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">         <span class="py-keyword">if</span> entry:</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">            link = rel(self.filename(), entry.link)</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">            item = href(link, label)</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">         <span class="py-keyword">else</span>:</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">            item = label</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">         doc = div(<span class="py-string">'doc'</span>, self.processor.documentation.summary(decl, self))</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">         self.write(div(<span class="py-string">'item'</span>, item + <span class="py-string">'\n'</span> + doc) + <span class="py-string">'\n'</span>)</span>
<a id="line134"></a><span class="lineno">134</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">      <span class="py-comment"># Close open div</span></span>
<a id="line136"></a><span class="lineno">136</span><span class="line">      <span class="py-keyword">if</span> curr_scope <span class="py-keyword">is</span> <span class="py-keyword">not</span> None:</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">         self.write(<span class="py-string">'&lt;/div&gt;\n'</span>)</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">      self.end_file()</span>
<a id="line139"></a><span class="lineno">139</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
